/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 788:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.compile = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
const transformer_1 = __nccwpck_require__(955);
function compile(wrapperName, source) {
    if (source.startsWith("#!")) {
        source = "//" + source;
    }
    const tree = typescript_1.default.createSourceFile("", source, typescript_1.default.ScriptTarget.ESNext, true, typescript_1.default.ScriptKind.JS);
    const printer = typescript_1.default.createPrinter();
    const transformer = (context) => {
        const utils = {
            wrapperName: wrapperName,
            visit(node) {
                return typescript_1.default.visitNode(node, visit);
            },
            createWrapperCall(name, target, params) {
                const pos = typescript_1.default.getLineAndCharacterOfPosition(tree, target.getStart());
                const posArray = typescript_1.default.factory.createArrayLiteralExpression([
                    typescript_1.default.factory.createNumericLiteral(pos.line + 1),
                    typescript_1.default.factory.createNumericLiteral(pos.character + 1),
                ]);
                return typescript_1.default.factory.createCallExpression(typescript_1.default.factory.createIdentifier(`${this.wrapperName}.${name}`), undefined, [...params, posArray]);
            },
        };
        const visit = (node) => {
            for (const transformer of transformer_1.transformers) {
                const newNode = transformer(node, utils);
                if (newNode) {
                    return newNode;
                }
            }
            return typescript_1.default.visitEachChild(node, visit, context);
        };
        return (node) => typescript_1.default.visitNode(node, visit);
    };
    const transformedTree = typescript_1.default.transform(tree, [transformer]);
    const code = transformedTree.transformed.map((n) => printer.printFile(n));
    return code.join("\n");
}
exports.compile = compile;


/***/ }),

/***/ 605:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.arrowFunctionTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
const utils_1 = __nccwpck_require__(114);
//  (({y}) => ())(x)
const arrowFunctionTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isArrowFunction(node) ||
        node.body === undefined ||
        node.parameters.length === 0) {
        return null;
    }
    // Transform
    const { newParameters, newStatements } = (0, utils_1.replaceParams)(node, utils);
    let oldStatements = [];
    const oldBody = utils.visit(node.body);
    if (typescript_1.default.isBlock(oldBody)) {
        oldStatements.push(...oldBody.statements);
    }
    else {
        oldStatements.push(typescript_1.default.factory.createReturnStatement(oldBody));
    }
    return typescript_1.default.factory.updateArrowFunction(node, node.modifiers, node.typeParameters, newParameters, node.type, node.equalsGreaterThanToken, typescript_1.default.factory.createBlock([...newStatements, ...oldStatements]));
};
exports.arrowFunctionTransformer = arrowFunctionTransformer;
exports["default"] = exports.arrowFunctionTransformer;


/***/ }),

/***/ 182:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.elementAccessTransformer = exports.doRequireBind = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
const utils_1 = __nccwpck_require__(114);
function doRequireBind(node) {
    if (typescript_1.default.isCallExpression(node.parent)) {
        return !node.parent.arguments.some((x) => x === node);
    }
    return false;
}
exports.doRequireBind = doRequireBind;
// x[y]
const elementAccessTransformer = (node, utils) => {
    // Check
    if ((0, utils_1.isInAssignation)(node) ||
        !typescript_1.default.isElementAccessExpression(node) ||
        node.expression.kind === typescript_1.default.SyntaxKind.SuperKeyword) {
        return null;
    }
    if (typescript_1.default.isPostfixUnaryExpression(node.parent) ||
        typescript_1.default.isPrefixUnaryExpression(node.parent)) {
        return node;
    }
    const requireBind = doRequireBind(node);
    // TODO: Implement a better check than this, this is just a quick fix
    const isAsync = node.getText().includes("await");
    const k = typescript_1.default.factory.createIdentifier(utils.wrapperName + "k");
    const v = typescript_1.default.factory.createIdentifier(utils.wrapperName + "v");
    const nextgen = typescript_1.default.factory.createParenthesizedExpression(typescript_1.default.factory.createCallExpression(typescript_1.default.factory.createParenthesizedExpression(typescript_1.default.factory.createArrowFunction(isAsync
        ? [typescript_1.default.factory.createModifier(typescript_1.default.SyntaxKind.AsyncKeyword)]
        : [], undefined, [], undefined, typescript_1.default.factory.createToken(typescript_1.default.SyntaxKind.EqualsGreaterThanToken), typescript_1.default.factory.createBlock([
        typescript_1.default.factory.createVariableStatement(undefined, typescript_1.default.factory.createVariableDeclarationList([
            typescript_1.default.factory.createVariableDeclaration(k, undefined, undefined, node.expression),
        ], typescript_1.default.NodeFlags.Const)),
        typescript_1.default.factory.createVariableStatement(undefined, typescript_1.default.factory.createVariableDeclarationList([
            typescript_1.default.factory.createVariableDeclaration(v, undefined, undefined, node.argumentExpression),
        ], typescript_1.default.NodeFlags.Const)),
        typescript_1.default.factory.createExpressionStatement(utils.createWrapperCall("elem", node.argumentExpression, [k, v])),
        typescript_1.default.factory.createReturnStatement(requireBind
            ? typescript_1.default.factory.createCallExpression(typescript_1.default.factory.createPropertyAccessExpression(typescript_1.default.factory.createElementAccessExpression(k, v), typescript_1.default.factory.createIdentifier("bind")), undefined, [k])
            : typescript_1.default.factory.createElementAccessExpression(k, v)),
    ], true))), undefined, []));
    if (isAsync) {
        return typescript_1.default.factory.createAwaitExpression(nextgen);
    }
    return nextgen;
};
exports.elementAccessTransformer = elementAccessTransformer;
exports["default"] = exports.elementAccessTransformer;


/***/ }),

/***/ 948:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.forInStatementTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
// for (let y in x)
const forInStatementTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isForInStatement(node)) {
        return null;
    }
    // Transform
    const newNode = utils.createWrapperCall("forIn", node.expression, [
        utils.visit(node.expression),
    ]);
    return typescript_1.default.factory.updateForInStatement(node, utils.visit(node.initializer), newNode, utils.visit(node.statement));
};
exports.forInStatementTransformer = forInStatementTransformer;
exports["default"] = exports.forInStatementTransformer;


/***/ }),

/***/ 360:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.functionDeclarationTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
const utils_1 = __nccwpck_require__(114);
// function f({y}) {}
const functionDeclarationTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isFunctionDeclaration(node) ||
        node.body === undefined ||
        node.parameters.length === 0) {
        return null;
    }
    // Transform
    const { newParameters, newStatements } = (0, utils_1.replaceParams)(node, utils);
    return typescript_1.default.factory.updateFunctionDeclaration(node, node.modifiers, node.asteriskToken, node.name, node.typeParameters, newParameters, node.type, typescript_1.default.factory.createBlock([
        ...newStatements,
        ...utils.visit(node.body).statements,
    ]));
};
exports.functionDeclarationTransformer = functionDeclarationTransformer;
exports["default"] = exports.functionDeclarationTransformer;


/***/ }),

/***/ 931:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.functionExpressionTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
const utils_1 = __nccwpck_require__(114);
// function f({y}) {}
const functionExpressionTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isFunctionExpression(node) ||
        node.body === undefined ||
        node.parameters.length === 0) {
        return null;
    }
    // Transform
    const { newParameters, newStatements } = (0, utils_1.replaceParams)(node, utils);
    return typescript_1.default.factory.updateFunctionExpression(node, node.modifiers, node.asteriskToken, node.name, node.typeParameters, newParameters, node.type, typescript_1.default.factory.createBlock([
        ...newStatements,
        ...utils.visit(node.body).statements,
    ]));
};
exports.functionExpressionTransformer = functionExpressionTransformer;
exports["default"] = exports.functionExpressionTransformer;


/***/ }),

/***/ 37:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.InExpressionTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
/**
 * TODO: FIXME:
 * // We don't handle this
 * get name() {
 *   if (!this || !(#name in this)) { // transforms to !(ø.isIn(this, #name, [67, 29])) which is not valid javascript
 *     throw new ERR_INVALID_THIS('File');
 *   }
 *
 *   return this.#name;
 * }
 */
// if (y in x)
const InExpressionTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isBinaryExpression(node) ||
        node.operatorToken.kind !== typescript_1.default.SyntaxKind.InKeyword) {
        return null;
    }
    // Transform
    return utils.createWrapperCall("isIn", node.right, [
        utils.visit(node.right),
        utils.visit(node.left),
    ]);
};
exports.InExpressionTransformer = InExpressionTransformer;
exports["default"] = exports.InExpressionTransformer;


/***/ }),

/***/ 955:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.transformers = void 0;
const arrowFunction_1 = __importDefault(__nccwpck_require__(605));
const elementAccess_1 = __importDefault(__nccwpck_require__(182));
const forInStatement_1 = __importDefault(__nccwpck_require__(948));
const functionDeclaration_1 = __importDefault(__nccwpck_require__(360));
const functionExpression_1 = __importDefault(__nccwpck_require__(931));
const inExpression_1 = __importDefault(__nccwpck_require__(37));
const objectLiteral_1 = __importDefault(__nccwpck_require__(690));
const propertyAccess_1 = __importDefault(__nccwpck_require__(542));
const variableDeclaration_1 = __importDefault(__nccwpck_require__(437));
exports.transformers = [
    elementAccess_1.default,
    propertyAccess_1.default,
    variableDeclaration_1.default,
    objectLiteral_1.default,
    forInStatement_1.default,
    inExpression_1.default,
    arrowFunction_1.default,
    functionDeclaration_1.default,
    functionExpression_1.default,
];
exports["default"] = exports.transformers;


/***/ }),

/***/ 690:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.objectLiteralTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
// ({y} = x);
const objectLiteralTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isBinaryExpression(node) ||
        node.operatorToken.kind !== typescript_1.default.SyntaxKind.EqualsToken ||
        !typescript_1.default.isObjectLiteralExpression(node.left)) {
        return null;
    }
    // Transform
    function* iterPaths(node, path = []) {
        for (const prop of node.properties) {
            if (typescript_1.default.isShorthandPropertyAssignment(prop)) {
                yield typescript_1.default.factory.createArrayLiteralExpression([
                    ...path,
                    typescript_1.default.factory.createStringLiteral(prop.name.text),
                ]);
            }
            if (typescript_1.default.isPropertyAssignment(prop) && typescript_1.default.isIdentifier(prop.name)) {
                if (typescript_1.default.isIdentifier(prop.initializer)) {
                    yield typescript_1.default.factory.createArrayLiteralExpression([
                        ...path,
                        typescript_1.default.factory.createStringLiteral(prop.name.text),
                    ]);
                }
                if (typescript_1.default.isObjectLiteralExpression(prop.initializer)) {
                    yield* iterPaths(prop.initializer, [
                        ...path,
                        typescript_1.default.factory.createStringLiteral(prop.name.text),
                    ]);
                }
            }
            if (typescript_1.default.isPropertyAssignment(prop) &&
                typescript_1.default.isComputedPropertyName(prop.name)) {
                yield typescript_1.default.factory.createArrayLiteralExpression([
                    ...path,
                    prop.name.expression,
                ]);
            }
        }
    }
    const paths = Array.from(iterPaths(node.left));
    const newNode = utils.createWrapperCall("bind", node.right, [
        utils.visit(node.right),
        typescript_1.default.factory.createArrayLiteralExpression(paths),
    ]);
    return typescript_1.default.factory.updateBinaryExpression(node, utils.visit(node.left), node.operatorToken, newNode);
};
exports.objectLiteralTransformer = objectLiteralTransformer;
exports["default"] = exports.objectLiteralTransformer;


/***/ }),

/***/ 542:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.propertyAccessTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
const utils_1 = __nccwpck_require__(114);
// x.y
const propertyAccessTransformer = (node, utils) => {
    // Check
    if ((0, utils_1.isInAssignation)(node) ||
        !typescript_1.default.isPropertyAccessExpression(node) ||
        node.expression.kind === typescript_1.default.SyntaxKind.SuperKeyword) {
        return null;
    }
    // Transform
    const newNode = utils.createWrapperCall("prop", node.name, [
        utils.visit(node.expression),
        typescript_1.default.factory.createStringLiteral(node.name.text),
    ]);
    return typescript_1.default.factory.updatePropertyAccessExpression(node, newNode, utils.visit(node.name));
};
exports.propertyAccessTransformer = propertyAccessTransformer;
exports["default"] = exports.propertyAccessTransformer;


/***/ }),

/***/ 114:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.replaceParams = exports.iterBindingPatternPath = exports.isInAssignation = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
function isAssignation(operator) {
    const assignationTokens = [
        /*    = */ typescript_1.default.SyntaxKind.EqualsToken,
        /*   += */ typescript_1.default.SyntaxKind.PlusEqualsToken,
        /*   -= */ typescript_1.default.SyntaxKind.MinusEqualsToken,
        /*   *= */ typescript_1.default.SyntaxKind.AsteriskEqualsToken,
        /*  **= */ typescript_1.default.SyntaxKind.AsteriskAsteriskEqualsToken,
        /*   /= */ typescript_1.default.SyntaxKind.SlashEqualsToken,
        /*   %= */ typescript_1.default.SyntaxKind.PercentEqualsToken,
        /*  <<= */ typescript_1.default.SyntaxKind.LessThanLessThanEqualsToken,
        /*  >>= */ typescript_1.default.SyntaxKind.GreaterThanGreaterThanEqualsToken,
        /* >>>= */ typescript_1.default.SyntaxKind.GreaterThanGreaterThanGreaterThanEqualsToken,
        /*   &= */ typescript_1.default.SyntaxKind.AmpersandEqualsToken,
        /*  &&= */ typescript_1.default.SyntaxKind.AmpersandAmpersandEqualsToken,
        /*   |= */ typescript_1.default.SyntaxKind.BarEqualsToken,
        /*  ||= */ typescript_1.default.SyntaxKind.BarBarEqualsToken,
        /*  ??= */ typescript_1.default.SyntaxKind.QuestionQuestionEqualsToken,
        /*   ^= */ typescript_1.default.SyntaxKind.CaretEqualsToken,
    ];
    return assignationTokens.includes(operator);
}
function isInAssignation(node) {
    return (node.parent &&
        typescript_1.default.isBinaryExpression(node.parent) &&
        isAssignation(node.parent.operatorToken.kind) &&
        node.parent.left == node);
}
exports.isInAssignation = isInAssignation;
function* iterBindingPatternPath(node, path = []) {
    for (const elem of node.elements) {
        const x = typescript_1.default.isShorthandPropertyAssignment(elem);
        if (!elem.propertyName) {
            if (typescript_1.default.isIdentifier(elem.name)) {
                yield typescript_1.default.factory.createArrayLiteralExpression([
                    ...path,
                    typescript_1.default.factory.createStringLiteral(elem.name.text),
                ]);
            }
            continue;
        }
        if (typescript_1.default.isIdentifier(elem.propertyName)) {
            if (typescript_1.default.isIdentifier(elem.name)) {
                yield typescript_1.default.factory.createArrayLiteralExpression([
                    ...path,
                    typescript_1.default.factory.createStringLiteral(elem.propertyName.text),
                ]);
            }
            if (typescript_1.default.isObjectBindingPattern(elem.name)) {
                yield* iterBindingPatternPath(elem.name, [
                    ...path,
                    typescript_1.default.factory.createStringLiteral(elem.propertyName.getText()),
                ]);
            }
        }
        if (typescript_1.default.isComputedPropertyName(elem.propertyName)) {
            yield typescript_1.default.factory.createArrayLiteralExpression([
                ...path,
                elem.propertyName.expression,
            ]);
        }
    }
}
exports.iterBindingPatternPath = iterBindingPatternPath;
function replaceParams(node, utils) {
    const newParameters = [];
    const newDeclarations = [];
    for (const param of node.parameters) {
        if (typescript_1.default.isObjectBindingPattern(param.name)) {
            const paths = Array.from(iterBindingPatternPath(param.name));
            const name = `${utils.wrapperName}_${newDeclarations.length}`;
            const identifier = typescript_1.default.factory.createIdentifier(name);
            const newNode = utils.createWrapperCall("bind", param, [
                identifier,
                typescript_1.default.factory.createArrayLiteralExpression(paths),
            ]);
            newDeclarations.push(typescript_1.default.factory.createVariableDeclaration(param.name, undefined, undefined, newNode));
            newParameters.push(typescript_1.default.factory.updateParameterDeclaration(param, param.modifiers, param.dotDotDotToken, identifier, param.questionToken, param.type, param.initializer));
        }
        else {
            newParameters.push(param);
        }
    }
    let newStatements = [];
    if (newDeclarations.length !== 0) {
        newStatements.push(typescript_1.default.factory.createVariableStatement(undefined, typescript_1.default.factory.createVariableDeclarationList(newDeclarations, typescript_1.default.NodeFlags.Let)));
    }
    return { newParameters, newStatements };
}
exports.replaceParams = replaceParams;


/***/ }),

/***/ 437:
/***/ (function(__unused_webpack_module, exports, __nccwpck_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.variableDeclarationTransformer = void 0;
const typescript_1 = __importDefault(__nccwpck_require__(440));
const utils_1 = __nccwpck_require__(114);
// const {y} = x;
const variableDeclarationTransformer = (node, utils) => {
    // Check
    if (!typescript_1.default.isVariableDeclaration(node) ||
        !typescript_1.default.isObjectBindingPattern(node.name) ||
        node.initializer === undefined) {
        return null;
    }
    // Transform
    const paths = Array.from((0, utils_1.iterBindingPatternPath)(node.name));
    const newNode = utils.createWrapperCall("bind", node.initializer, [
        utils.visit(node.initializer),
        typescript_1.default.factory.createArrayLiteralExpression(paths),
    ]);
    return typescript_1.default.factory.updateVariableDeclaration(node, utils.visit(node.name), node.exclamationToken, node.type, newNode);
};
exports.variableDeclarationTransformer = variableDeclarationTransformer;
exports["default"] = exports.variableDeclarationTransformer;


/***/ }),

/***/ 440:
/***/ ((module) => {

module.exports = require("typescript");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __nccwpck_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		var threw = true;
/******/ 		try {
/******/ 			__webpack_modules__[moduleId].call(module.exports, module, module.exports, __nccwpck_require__);
/******/ 			threw = false;
/******/ 		} finally {
/******/ 			if(threw) delete __webpack_module_cache__[moduleId];
/******/ 		}
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat */
/******/ 	
/******/ 	if (typeof __nccwpck_require__ !== 'undefined') __nccwpck_require__.ab = __dirname + "/";
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __nccwpck_require__(788);
/******/ 	module.exports = __webpack_exports__;
/******/ 	
/******/ })()
;